function X = project_L1LInf_core(C, tau1, tau2, w)

eps = 1e-9;
left = 0;
right = max(max(C));
nu = 0;
delta = 10*eps;

iteration = 0;
while abs(delta) > eps
    iteration = iteration + 1;
    if delta > eps
        left = nu;
    else
        right = nu;
    end
    nu = (left + right)/2;
    X = max(C-nu,0);
    X = MyL1InfProjection(X, tau1, w);
    delta = sum(sum(X)) - tau2;    
end